
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

yarip.Map = function()
{
	this.obj = {};
	this.deep = null;
//	this.changesMade = false;

/*	this.setChanged = function()
	{
		this.changesMade = true;
	}

	this.resetChanged = function()
	{
		this.changesMade = false;
	}*/

	this.clone = function()
	{
		var map = new this.constructor();
		for (var pageAddress in this.obj) if (this.obj[pageAddress]) map.obj[pageAddress] = this.obj[pageAddress].clone();
		return map;
	}

	this.sortPages = function(reduce)
	{
//		if (!this.changesMade) return;
		var aPage = [];
		for (var pageAddress in this.obj)
		{
			if (!this.obj[pageAddress]) continue;
			this.obj[pageAddress].whitelist.sortXPaths(reduce);
			this.obj[pageAddress].blacklist.sortXPaths(reduce);
			aPage.push(this.obj[pageAddress]);
		}
		aPage.sort(yarip.PageSorter);
		this.obj = {};
		for (var i = 0; i < aPage.length; i++) this.obj[aPage[i].getName()] = aPage[i];
//		this.changesMade = false;
	}

	this.generateXml = function()
	{
		var r = "<?xml version=\"1.0\" encoding=\"" + yarip.CHARSET + "\"?>\n<yarip>\n";
		for (var pageAddress in this.obj) if (this.obj[pageAddress]) r += this.obj[pageAddress].generateXml();
		r += "</yarip>";
		return r;
	}
}
