
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

yarip.XPath = function(value, deep, found, notFound, whitelisted)
{
	this.value = "";
	this.deep = true;
	this.found = 0;
	this.notFound = 0;
	this.whitelisted = 0;

	this.setValue = function(value)
	{
		if (value) this.value = "" + value;
	}

	this.getValue = function()
	{
		return this.value;
	}

	this.setDeep = function(deep)
	{
		this.deep = "" + deep != "false";
	}

	this.getDeep = function()
	{
		return this.deep;
	}

	this.setFound = function(value)
	{
		if (value) this.found = value;
	}

	this.getFound = function()
	{
		return this.found;
	}

	this.incrementFound = function()
	{
		this.found++;
	}

	this.setNotFound = function(value)
	{
		if (value) this.notFound = value;
	}

	this.getNotFound = function()
	{
		return this.notFound;
	}

	this.incrementNotFound = function()
	{
		this.notFound++;
	}

	this.setWhitelisted = function(value)
	{
		if (value) this.whitelisted = value;
	}

	this.getWhitelisted = function()
	{
		return this.whitelisted;
	}

	this.incrementWhitelisted = function()
	{
		this.whitelisted++;
	}

	this.clone = function(purge)
	{
		var xpath = new this.constructor(this.value, this.deep, this.found, this.notFound, this.whitelisted);
		if (purge)
		{
			xpath.found = 0;
			xpath.notFound = 0;
			xpath.whitelisted = 0;
		}
		return xpath;
	}

	this.generateXml = function()
	{
		var r = "\t\t\t<xpath value=\"" + this.value + "\"";
		if (this.deep == false) r += " deep=\"false\"";
		if (this.found > 0) r += " found=\"" + this.found + "\"";
		if (this.notFound > 0) r += " notFound=\"" + this.notFound + "\"";
		if (this.whitelisted > 0) r += " whitelisted=\"" + this.whitelisted + "\"";
		r += "/>\n";
		return r;
	}

	this.setValue(value);
	this.setDeep(deep);
	this.setFound(found);
	this.setNotFound(notFound);
	this.setWhitelisted(whitelisted);
}

yarip.XPathSorter = function(a, b)
{
	a = a.value;
	b = b.value;
	if (a.length < b.length)
	{
		if (b.indexOf(a) == 0) return -1;
		return yarip.normalSort(a, b);
	}
	if (a.length > b.length)
	{
		if (a.indexOf(b) == 0) return 1;
		return yarip.normalSort(a, b);
	}
	return yarip.normalSort(a, b);
}
