
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var yarip = {
	ADDRESS_MODE: {
		page: 0,
		fqdn: 1,
		sld: 2,
		user: 3
	},

	LIST_TYPE: {
		whitelist: 0,
		blacklist: 1
	},

	FLICKER_TYPE: {
		allow: 0,
		prevent: 1,
		auto: 2
	},

	CHANGE_TYPE: {
		none: 0,
		minor: 1,
		essential: 2
	},

	BOOLEAN: "boolean",
	INTEGER: "integer",
	STRING: "string",
	RESET: "reset",

	FIRSTRUN: "extensions.yarip.firstrun",
	VERSION: "extensions.yarip.version",
	ENABLED_ROOT: "extensions.yarip.enabled.",
	ENABLED: "extensions.yarip.enabled.value",
	MODE_ROOT: "extensions.yarip.mode.",
	MODE: "extensions.yarip.mode.value",
	RELOAD_ROOT: "extensions.yarip.reload.",
	RELOAD: "extensions.yarip.reload.value",
	CHANGE: "extensions.yarip.changeType.value",
	FLICKER_ROOT: "extensions.yarip.flickerType.",
	FLICKER: "extensions.yarip.flickerType.value",
	INDEX_ROOT: "extensions.yarip.alwaysUseIndex.",
	INDEX: "extensions.yarip.alwaysUseIndex.value",
	VALUE: "value",

	CHARSET: "UTF-8",

	address: null,
	undoObj: {},
	alwaysUseIndex: true,
	changeType: null,

	$: function(id)
	{
		return document.getElementById(id);
	}
}

yarip.OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
yarip.UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
yarip.SCHEME = "(" + yarip.OFFICIAL_SCHEME + "|" + yarip.UNOFFICIAL_SCHEME + "):";
yarip.IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
yarip.IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
yarip.IP = "(" + yarip.IPV4ADDRESS + "|" + yarip.IP_LITERAL + ")";
yarip.AUTHORITY = "([a-z\\d]([\\w-.~!$&*+,=:]|%[a-f\\d]{2})*@)?";
yarip.REG_NAME = "([a-z\\d]([\\w-~!$&*+,=@]|%[a-f\\d]{2})+\\.)+";
yarip.HOSTNAME = "[a-z\\d]([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.SLD = "[a-z\\d]([\\w-~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
yarip.HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + yarip.IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)(:\\d+)?))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
yarip.PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
yarip.QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";

yarip.URI1 = "(" + yarip.SCHEME + yarip.HIER_PART + yarip.QUERY_FRAGMENT + ")";
yarip.URI2 = "(" + yarip.AUTHORITY + "(" + yarip.IP + "|(" + yarip.REG_NAME + yarip.TLD + "\\b))(:\\d+)?" + yarip.PATH + yarip.QUERY_FRAGMENT + ")";

yarip.uriRegExp = new RegExp("^(" + yarip.URI1 + "|" + yarip.URI2 + ")$", "i");
yarip.noSchemeRegExp = new RegExp("^" + yarip.URI2 + "$", "i");
yarip.domainRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.HOSTNAME + yarip.TLD + "))\\b", "i");
yarip.sldRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.SLD + yarip.TLD + "))$", "i");

yarip.setChangeType = function(type, force)
{
	if (!this.changeType || type > this.changeType || force) this.changeType = type;
}

yarip.getAddress = function(doc, mode)
{
	if (!doc || typeof mode != "number") return null;
	if (!doc.location) return null;

	var address = null;
	try
	{
		switch(mode)
		{
			case this.ADDRESS_MODE.page:
				address = doc.location.protocol + "//" + doc.location.host + doc.location.pathname;
				break;

			case this.ADDRESS_MODE.fqdn:
				address = doc.location.hostname;
				break;

			case this.ADDRESS_MODE.sld:
				var sld = doc.location.hostname.match(this.sldRegExp);
				if (sld) address = sld[0];
				break;

			case this.ADDRESS_MODE.user:
				address = this.address;
		}
		if (address == "") return null;
	}
	catch(e){}
	return address;
}

yarip.getAddressArray = function(doc, map)
{
	if (!doc || !map) return null;

	var aAddress = [];
	var tmpDomain = null;
	var reduceDomain = this.getAddress(doc, this.ADDRESS_MODE.page);
	while (reduceDomain != tmpDomain)
	{
		var tmpPath = null;
		var reducePath = reduceDomain;

		while (reducePath != tmpPath)
		{
			if (map.obj[reducePath]) aAddress.push(reducePath);
			tmpPath = reducePath;
			reducePath = reducePath.replace(/(\/|[^/]*)$/, "");
		}

		tmpDomain = reduceDomain;
		reduceDomain = reduceDomain.replace(/^([^:]+:\/\/|[^.]+\.)/, "");
	}
	return aAddress;
}

yarip.resetOnAddress = function(doc, map, address, xpath, show)
{
	if (!doc || !map || !address) return false;

	var whitelist = map.obj[address] ? map.obj[address].whitelist : null;
	var blacklist = map.obj[address] ? map.obj[address].blacklist : null;

	if (!xpath)
	{
		if (whitelist) for (var xValue in whitelist.xpaths) if (whitelist.xpaths[xValue]) this.resetOnAddress(doc, map, address, whitelist.xpaths[xValue]);
		if (blacklist) for (var xValue in blacklist.xpaths) if (blacklist.xpaths[xValue]) this.resetOnAddress(doc, map, address, blacklist.xpaths[xValue]);
		return true;
	}

	if (show)
	{
		var elements = this.getElementsByXPath(doc, xpath.value);
		if (elements) for (var i = 0; i < elements.snapshotLength; i++)
		{
			var element = elements.snapshotItem(i);
			switch (element.getAttribute("status"))
			{
				case "whitelisted":
				case "blacklisted":
					element.removeAttribute("status");
			}
		}
	}

	if (whitelist) whitelist.remove(xpath);
	if (blacklist) blacklist.remove(xpath);
	this.setChangeType(this.CHANGE_TYPE.minor);
	this.undoObj[xpath.value] = null;

	return true;
}

yarip.whitelist = function(doc, map, address, xpath, isNew)
{
	if (!doc || !map || !address || !xpath) return false;

	var elements = this.getElementsByXPath(doc, xpath.value);
	if (!elements) return false;

	var whitelist = map.obj[address] ? map.obj[address].whitelist : null;
	var found = false;

	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		if (element.getAttribute("status") == "whitelisted")
		{
			if (whitelist && whitelist.xpaths[xpath.value])
			{
				whitelist.xpaths[xpath.value].incrementWhitelisted();
				this.setChangeType(this.CHANGE_TYPE.minor);
			}
			continue;
		}

		if (isNew) element.setAttribute("status", "whitelisted");
		else while (element && element.nodeType == 1 && element.getAttribute("status") != "whitelisted")
		{
			element.setAttribute("status", "whitelisted");
			element = element.parentNode;
		}

		found = true;
	}

	if (found && isNew)
	{
		if (!map.obj[address]) map.obj[address] = new this.Page(address);
		map.obj[address].whitelist.add(xpath);
		this.setChangeType(this.CHANGE_TYPE.minor);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xpath.value;
		obj.type = this.LIST_TYPE.whitelist;
		this.undoObj[xpath.value] = obj;
	}

	return found;
}

yarip.blacklist = function(doc, map, address, xpath, isNew, force)
{
	if (!doc || !map || !address || !xpath) return false;

	var elements = this.getElementsByXPath(doc, xpath.value);
	if (!elements) return false;

	var blacklist = map.obj[address] ? map.obj[address].blacklist : null;
	var found = false;

	for (var i = 0; i < elements.snapshotLength; i++)
	{
		var element = elements.snapshotItem(i);

		switch (element.nodeType)
		{
			// ELEMENT
			case 1:
				if (!force && element.getAttribute("status") == "whitelisted")
				{
					if (blacklist && blacklist.xpaths[xpath.value])
					{
						blacklist.xpaths[xpath.value].incrementWhitelisted();
						this.setChangeType(this.CHANGE_TYPE.minor);
					}
					continue;
				}

				if (element.localName.match(/^(html|body)$/i)) continue;

				element.setAttribute("status", "blacklisted");
				if (element.localName.match(/^i?frame$/i)) element.setAttribute("src", "about:blank");
				if (!isNew) element.innerHTML = "";

				break;

			// ATTRIBUTE
			case 2:
				element.ownerElement.removeAttribute(element.name);
		}

		found = true;
	}

	if (found && isNew)
	{
		if (!map.obj[address]) map.obj[address] = new this.Page(address);
		map.obj[address].blacklist.add(xpath);
		this.setChangeType(this.CHANGE_TYPE.minor);
		var obj = {}
		obj.document = doc;
		obj.address = address;
		obj.xValue = xpath.value;
		obj.type = this.LIST_TYPE.blacklist;
		this.undoObj[xpath.value] = obj;
	}

	return found;
}

yarip.calculateXPath = function(element, fullPath)
{
	if (!element) return null;
	if (!element.localName) return null;

	var xValue = "";
	do
	{
		var attributes = "";
		if (element.getAttribute("id"))
		{
			// ID
			attributes += "[@id='" + element.getAttribute("id") + "']";
			if (!fullPath) return "//" + element.localName.toLowerCase() + attributes + xValue; // shortest xpath
		}
		else
		{
			// ATTRIBUTES
			if (element.getAttribute("name")) attributes += "@name='" + element.getAttribute("name") + "' and ";
			if (element.getAttribute("class")) attributes += "@class='" + element.getAttribute("class") + "' and ";
			if (attributes != "") attributes = "[" + attributes.substring(0, attributes.length - 5) + "]";

			// INDEX
			if (!element.localName.match(/^(html|head|title|body|thead|tbody|tfoot|frameset)$/i))
			{
				var index = 1;
				var sibling = element.previousSibling;
				while (sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) ++index;
					sibling = sibling.previousSibling;
				}

				var found = false;
				sibling = element.nextSibling;
				while (!found && sibling)
				{
					if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) found = true;
					else sibling = sibling.nextSibling;
				}
				if (found || index > 1 || this.alwaysUseIndex) attributes = "[" + index + "]" + attributes;
			}
		}
		xValue = "/" + element.localName.toLowerCase() + attributes + xValue;

		element = element.parentNode;
	} while (element && element.nodeType == 1);

	return xValue != "" ? xValue : null;
}

yarip.getElementsByXPath = function(doc, xValue)
{
	var elements = null;
	try { elements = doc.evaluate(xValue, doc, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null); }
	catch(e)
	{
		var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
		var scriptError = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
		var message = this.$("yarip-overlay-stringbundle").getFormattedString("malformed-xpath", [xValue]);
		var sourceName = "chrome://yarip/content/yarip.js";
		scriptError.init(message, sourceName, null, e.lineNumber, e.columnNumber, scriptError.errorFlag, "content javascript");
		consoleService.logMessage(scriptError);
	}
//	if (!elements || elements.snapshotLength == 0) return null;
	return elements;
}

yarip.normalSort = function(a, b) {
	if (a < b) return -1;
	if (a > b) return 1;
	return 0;
}
